'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (Component) {
  var _class, _temp2;

  return _temp2 = _class = function (_React$Component) {
    _inherits(_scrollAware, _React$Component);

    function _scrollAware() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, _scrollAware);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _scrollAware.__proto__ || Object.getPrototypeOf(_scrollAware)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
        scrollableAncestor: null
      }, _this._componentHandleScroll = function (event) {
        if (_this.Component.type.prototype[_this.props.handleScroll]) {
          _this._componentHandleScroll = _this.Component.type.prototype[_this.props.handleScroll].bind(_this.Component);
          _this._componentHandleScroll(event);
        } else {
          (0, _warning2.default)(false, '[scrollAware]: Returned Component instance does not have a "' + _this.props.handleScroll + '" class method');
        }
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(_scrollAware, [{
      key: '_handleScroll',
      value: function _handleScroll(event) {
        this._componentHandleScroll(event);
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (!(0, _utils.getWindow)()) {
          return;
        }

        this._handleScroll = this.props.throttleHandler(this._handleScroll.bind(this));
        this.scrollableAncestor = this.props.scrollableAncestor || (0, _utils.findScrollableAncestor)(_reactDom2.default.findDOMNode(this));
        this.scrollableAncestor.addEventListener('scroll', this._handleScroll);
        window.addEventListener('resize', this._handleScroll);

        this.setState({ scrollableAncestor: this.scrollableAncestor });
      }
    }, {
      key: 'componentDidUpdate',
      value: function componentDidUpdate() {
        if (!(0, _utils.getWindow)()) {
          return;
        }

        // The element may have moved.
        this._handleScroll(null);
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        if (!(0, _utils.getWindow)()) {
          return;
        }

        // At the time of unmounting, the scrollable ancestor might no longer
        // exist. Guarding against this prevents the following error:
        //
        //   Cannot read property 'removeEventListener' of undefined
        this.scrollableAncestor && this.scrollableAncestor.removeEventListener('scroll', this._handleScroll);
        window.removeEventListener('resize', this._handleScroll);

        // cancel throttle function if possible
        this.props.throttleHandler.cancel && this.props.throttleHandler.cancel.call(this);
      }

      /**
       * @return {Object}
       */

    }, {
      key: 'render',
      value: function render() {
        var _props = this.props;
        var scrollableAncestor = _props.scrollableAncestor;
        var throttleHandler = _props.throttleHandler;
        var handleScroll = _props.handleScroll;

        var props = _objectWithoutProperties(_props, ['scrollableAncestor', 'throttleHandler', 'handleScroll']); // eslint-disable-line no-unused-vars


        this.Component = _react2.default.createElement(Component, _extends({}, props, { scrollableAncestor: this.state.scrollableAncestor }));
        return this.Component;
      }
    }]);

    return _scrollAware;
  }(_react2.default.Component), _class.propTypes = {
    scrollableAncestor: _react.PropTypes.any,
    throttleHandler: _react.PropTypes.func,
    handleScroll: _react.PropTypes.string
  }, _class.defaultProps = {
    throttleHandler: function throttleHandler(handler) {
      return handler;
    },

    handleScroll: '_handleScroll'
  }, _temp2;
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utils = require('./utils');

var _warning = require('fbjs/lib/warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @param {function} Component
 * Calls a function when you scroll to the element.
 * @return {function}
 */